import { useResourcesPolicy } from '@graphpolaris/shared/lib/data-access';
import { useMemo } from 'react';
//import casbinjs from 'casbin.js';
import { Authorizer } from 'casbin.js';
export const useCheckPermissionPolicy = () => {
  const policyPermissions = useResourcesPolicy();

  const authorizer = useMemo(() => {
    // docs tell to go this way, but it doesn't work
    //const auth = new casbinjs.Authorizer('manual');
    const auth = new Authorizer('manual');

    const permission = {
      read: policyPermissions.read,
      write: policyPermissions.write,
    };

    auth.setPermission(permission);

    return auth;
  }, [policyPermissions]);

  const canRead = async (resource: string) => {
    return await authorizer.can('read', resource);
  };

  const canWrite = async (resource: string) => {
    return await authorizer.can('write', resource);
  };

  return {
    canRead,
    canWrite,
  };
};
